## dpuser 3.3%2Bp1%2Bdfsg

=== debian/changelog ===
dpuser (3.3+p1+dfsg-2build1) artful; urgency=medium

  * No-change rebuild for libgsl soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 06 Aug 2017 00:09:39 +0000

dpuser (3.3+p1+dfsg-2) unstable; urgency=medium

  * Force LC_NUMERIC locale to "C". (Closes: #858094)

 -- Ole Streicher <olebole@debian.org>  Sat, 18 Mar 2017 13:57:17 +0100

dpuser (3.3+p1+dfsg-1) unstable; urgency=medium

  * Import version 3.3+p1+dfsg patched by upstream

 -- Ole Streicher <olebole@debian.org>  Wed, 27 Jul 2016 14:15:37 +0200

dpuser (3.3+dfsg-1) unstable; urgency=low

  * Imported Upstream version 3.3+dfsg

 -- Ole Streicher <olebole@debian.org>  Mon, 25 Jul 2016 17:23:00 +0200

dpuser (3.2+dfsg-3) unstable; urgency=medium

  * Fix several segfaults

 -- Ole Streicher <olebole@debian.org>  Sat, 23 Jul 2016 13:56:07 +0200

dpuser (3.2+dfsg-2) unstable; urgency=medium

  * Fix crash on i386 and other platforms

 -- Ole Streicher <olebole@debian.org>  Fri, 22 Jul 2016 14:56:22 +0200

dpuser (3.2+dfsg-1) unstable; urgency=low

  * Initial release. (Closes: #472961)

 -- Ole Streicher <olebole@debian.org>  Mon, 04 Jul 2016 12:58:07 +0200

## dpuser 3.3+p1+dfsg

=== dpuser/Makefile ===
################################################################################
# dpuser Makefile
################################################################################
# Type one of the following lines:
#   make                    same as 'make release'
#   make release            (static, 32/64-bit autodetect)
#   make release_shared     WIN only (shared, 32/64-bit autodetect)
#   make debug              (static, 32/64-bit autodetect)
#   make debug_shared       WIN only (shared, 32/64-bit autodetect)
#   make CYGWIN=-y          WIN only, target for CYGWIN-environment
#   make clean              to clean up the project
#   make revision           creates the revision-string
#   make dist               LINUX/MACOSX only to create a distribution as
#                           tar.gz-file, calls automatically the revision-target
#                           (do a checkout to a new location before, since all
#                           .svn-folders will be deleted!)
#
#
#   make parsers PLATFORM=LINUX (or MACOSX or WIN)
#                          to create just the parsers and lexxers for dpuser,
#                          dpuser2c & idl2c
#   make dpuser2c_header PLATFORM=LINUX (or MACOSX or WIN)
#                          to create just the dpuser2c.h-file
#
# In dpuser a static target means that all libraries and functionality is linked
# statically into the created binary.
# A shared target means that some dpuser-functionality is moved to a dll
# (external libraries are still linked statically).
#
################################################################################
RM          = rm -f
SED         = sed
CC          = gcc
CXX         = g++
LINK        = g++
QF          =
CYGWIN      =

PGPLOT      = -DHAS_PGPLOT
DPPGPLOT    = -DHAS_DPPGPLOT

DEFINES     = $(PGPLOT) $(DPPGPLOT) -D$(OS)
ifeq ($(QF), -qt)
   DEFINES  += -DDPQT -DNO_READLINE
endif
ifeq ($(CYGWIN), -y)
   DEFINES  += -DCYGWIN
endif

CFLAGS      = -pipe -O2 -D_REENTRANT -w $(DEFINES)
CXXFLAGS    = -pipe -O2 -D_REENTRANT -w $(DEFINES)
INCPATH     = -I. -I../utils -I../libfits -I../include -Iparser -I.

DLL_OBJECTS = utils.o \
              dpuser_utils.o \
              dpuser.procs.o \
              eso.o \
              functions.o \
              tools.o \
              y.dpuser2c.o \
              y.idl2c.o \
              lex.dpuser2c.o \
              lex.idl2c.o \
              procedures.o \
              dpuserType.o \
              dpstring.o \
              dpstringlist.o \
              regex_sr.o \
              mpfit.o \
              3d_stuff.o \
              cube.o \
              dpheader.o \
              fits.o \
              fits_cube.o \
              fits_dpl.o \
              fits_exc.o \
              fits_file.o \
              fits_filters.o \
              fits_funcs.o \
              fits_mem.o \
              fits_ops.o \
              fits_procs.o \
              fits_range.o \
              fits_red.o \
              JulianDay.o \
              math_utils.o \
              platform.o \
              dpComplex.o \
              fitting.o \
              voronoi.o \
              fits_logic.o \
              astrolib.o \
              primes.o

ifeq ($(PGPLOT), -DHAS_PGPLOT)
   ifeq ($(DPPGPLOT), -DHAS_DPPGPLOT)
      DLL_OBJECTS += cpg3d.o
   endif
endif

EXE_OBJECTS = dpuser.o \
              dpuser.yacchelper.o \
              dpuser_funcs.o \
              y.tab.o \
              dpuser.input.o \
              dpuser.pgplot.o \
              lex.yy.o \
              svn_revision.o \
              misc.o

################################################################################
# Platform-specific defines

ifeq ($(HOMEDRIVE), C:)
   OS             = WIN
   RM             = del
   SED_INPLACE    = ../bin/WIN/sed.exe -i
   
   # didn't manage to do this as onliner like in the unix-case, pipe doesn't work...
   REV_NR := $(shell svnversion -c ..)
   $(shell @echo $(REV_NR) > _bbb.txt)
   REV_NR := $(shell sed -e 's/[MS]//g' -e 's/^[[:digit:]]*://' _bbb.txt)
   $(shell del _bbb.txt)

   ifndef $(ARCH)
   # didn't manage to do this as onliner like in the unix-case, pipe doesn't work...
      ARCH := $(shell wmic os get osarchitecture)
      $(shell @echo $(ARCH) > _bbb.txt)
      ARCH := $(shell sed  -e "s/OSArchitecture//g" -e "s/ //g" -e "s/-bit//g" -e "s/-Bit//g" _bbb.txt)
      $(shell del _bbb.txt)
   endif

   DEFINES  += -DHAVE_MINGW32
   
   ifeq ($(CYGWIN), -y)
      LIBS     = /usr/lib/libreadline.a \
                 /usr/lib/libncurses.a \
                 ../lib/WIN32.cygwin/libgsl.a

      DLL_LIBS = ../lib/WIN32.cygwin/libgsl.a \
                 ../lib/WIN32.cygwin/libgslcblas.a \
                 ../lib/WIN32.cygwin/librfftw.a \
                 ../lib/WIN32.cygwin/libfftw.a \
                 ../lib/WIN32.cygwin/libcpgplot.a \
                 ../lib/WIN32.cygwin/libpgplot.a \
                 /usr/lib/libz.a \
                 /usr/lib/libpng.a \
                 ../lib/WIN32.cygwin/libxpa.a \
                 -lg2c \
                 -lgdi32
   else
      LIBS     = ../lib/$(OS)$(ARCH)/libgsl.a \
                 ../lib/$(OS)$(ARCH)/libreadline.a \
                 ../lib/$(OS)$(ARCH)/libtermcap.a

      DLL_LIBS = ../lib/$(OS)$(ARCH)/libgsl.a \
                 ../lib/$(OS)$(ARCH)/libgslcblas.a \
                 ../lib/$(OS)$(ARCH)/librfftw.a \
                 ../lib/$(OS)$(ARCH)/libfftw.a \
                 ../lib/$(OS)$(ARCH)/libcpgplot.a \
                 ../lib/$(OS)$(ARCH)/libpgplot.a \
                 ../lib/$(OS)$(ARCH)/libz.a \
                 ../lib/$(OS)$(ARCH)/libpng.a \
                 ../lib/$(OS)$(ARCH)/libxpa.a \
                 ../lib/$(OS)$(ARCH)/libf2c.a \
                 -lgdi32 \
                 -lws2_32
				 
      LDFLAG      =
   endif
	
   DEL_STRING     = 2d
else
   REV_NR := $(shell svnversion -c .. | sed -e 's/[MS]//g' -e 's/^[[:digit:]]*://')

   ifeq ($(shell uname -m), x86_64)
      ARCH = 64
   else
      ARCH = 32
   endif

   ifeq ($(TERM_PROGRAM), Apple_Terminal)
      OS          = MACOSX
      ifeq ($(ARCH), 32)
         LDFLAG      = -arch i386
         CXXFLAGS    := -arch i386 $(CXXFLAGS)
      else
         # -arch x86_64
         LDFLAG      = 
      endif
      SED_INPLACE = sed -i ''
      LIBS        = ../lib/$(OS)$(ARCH)/libxpa.a \
                    ../lib/$(OS)$(ARCH)/librfftw.a \
                    ../lib/$(OS)$(ARCH)/libfftw.a \
                    ../lib/$(OS)$(ARCH)/libcpgplot.a \
                    ../lib/$(OS)$(ARCH)/libpgplot.a \
                    ../lib/$(OS)$(ARCH)/libpng.a \
                    ../lib/$(OS)$(ARCH)/libgsl.a \
                    ../lib/$(OS)$(ARCH)/libgslcblas.a \
                    ../lib/$(OS)$(ARCH)/libreadline.a \
                    ../lib/$(OS)$(ARCH)/libz.a \
                    ../lib/$(OS)$(ARCH)/libncurses.a \
                    ../lib/$(OS)$(ARCH)/libf2c.a \
                    -L/opt/X11/lib \
                    -lX11

   else
      OS          = LINUX
      LDFLAG      =
      SED_INPLACE = sed -i''
      LIBS        = -rdynamic \
                    ../lib/$(OS)$(ARCH)/libxpa.a \
                    ../lib/$(OS)$(ARCH)/librfftw.a \
                    ../lib/$(OS)$(ARCH)/libfftw.a \
                    ../lib/$(OS)$(ARCH)/libcpgplot.a \
                    ../lib/$(OS)$(ARCH)/libgsl.a \
                    ../lib/$(OS)$(ARCH)/libgslcblas.a \
                    ../lib/$(OS)$(ARCH)/libpgplot.a \
                    ../lib/$(OS)$(ARCH)/libf2c.a \
                    ../lib/$(OS)$(ARCH)/libz.a \
                    ../lib/$(OS)$(ARCH)/libpng.a \
                    ../lib/$(OS)$(ARCH)/libreadline.a \
                    ../lib/$(OS)$(ARCH)/libncurses.a \
                    -lX11 -ldl -lxcb -lpthread -lXdmcp -lXau

   endif
   TARDIR     := $(shell echo $(PWD) | sed 's|/dpuser$$||g' | sed 's|\/.*\/||g')
   DEL_STRING = '2d'
endif

################################################################################
# main targets
all: release

##### RELEASE TARGETS #####
ifeq ($(OS), WIN) # start WIN
ifeq ($(CYGWIN), -y)
release:
	$(MAKE) static "TARGET_WIN = dpuserCyg.exe"
release_shared:
	$(MAKE) all_dp "TARGET_WIN = dpuserCyg.exe" "TARGET_DLL = dpuserCyg.dll"
else
release:
	$(MAKE) static "TARGET_WIN = dpuser.exe"
release_shared:
	$(MAKE) all_dp "TARGET_WIN = dpuser.exe" "TARGET_DLL = dpuser.dll"
endif # end WIN
else # start LINUX & MACOSX
release:
	$(MAKE) static "TARGET_LINUX = dpuser"
endif # end LINUX & MACOSX

##### DEBUG TARGETS #####
ifeq ($(OS), WIN) # start WIN
ifeq ($(CYGWIN), -y)
debug:
	$(MAKE) static "TARGET_WIN = dpuserCygD.exe" "CFLAGS = $(CFLAGS) -g -DDBG" "CXXFLAGS = $(CXXFLAGS) -g -DDBG"
debug_shared:
	$(MAKE) shared "TARGET_WIN = dpuserCygD.exe" "TARGET_DLL = dpuserCygD.dll" "CFLAGS = $(CFLAGS) -g -DDBG" "CXXFLAGS = $(CXXFLAGS) -g -DDBG"
else
debug:
	$(MAKE) static "TARGET_WIN = dpuserD.exe" "CFLAGS = $(CFLAGS) -g -DDBG" "CXXFLAGS = $(CXXFLAGS) -g -DDBG"
debug_shared:
	$(MAKE) shared "TARGET_WIN = dpuserD.exe" "TARGET_DLL = dpuserD.dll" "CFLAGS = $(CFLAGS) -g -DDBG" "CXXFLAGS = $(CXXFLAGS) -g -DDBG"
endif # end WIN
else # start LINUX & MACOSX
debug:
	$(MAKE) static "TARGET_LINUX = dpuserD" "CFLAGS = $(CFLAGS) -g -DDBG" "CXXFLAGS = $(CXXFLAGS) -g -DDBG"
endif # end LINUX & MACOSX

################################################################################
# sub targets

ifeq ($(OS), WIN) # start WIN
static: revision dpuser2c_header parsers $(DLL_OBJECTS) $(EXE_OBJECTS)
	$(LINK) $(LDFLAG) -static -static-libgcc -static-libstdc++ -Wl,--enable-runtime-pseudo-reloc -o $(TARGET_WIN) $(DLL_OBJECTS) $(EXE_OBJECTS) $(DLL_LIBS) $(LIBS)
shared: revision dpuser2c_header parsers
	$(MAKE) $(MULTIPROZGEIL) $(TARGET_DLL)
	$(MAKE) $(MULTIPROZGEIL) $(TARGET_WIN)
else # end WIN, start LINUX & MACOSX
static: revision dpuser2c_header parsers
	$(MAKE) $(MULTIPROZGEIL) $(TARGET_LINUX)
endif # end LINUX & MACOSX

$(TARGET_DLL): $(DLL_OBJECTS)
	g++ -shared -o $(TARGET_DLL) $(DLL_OBJECTS) $(DLL_LIBS)

$(TARGET_WIN): $(EXE_OBJECTS)
	$(LINK) -Wl,--enable-runtime-pseudo-reloc -o $(TARGET_WIN) $(EXE_OBJECTS) $(LIBS) $(TARGET_DLL)

$(TARGET_LINUX): $(DLL_OBJECTS) $(EXE_OBJECTS)
	$(LINK) $(LDFLAG) -o $(TARGET_LINUX) $(DLL_OBJECTS) $(EXE_OBJECTS) $(LIBS)

# creates dpuser2c.h
dpuser2c_header:
	$(MAKE) -C dpuser2c header PLATFORM=$(OS)

# Builds parser-, dpuser2c & idl2c-source-files
parsers: parsers_qf
	$(MAKE) -C parser PLATFORM=$(OS)

parsers_qf:
	$(MAKE) -C dpuser2c PLATFORM=$(OS)
	$(MAKE) -C idl2c PLATFORM=$(OS)

clean: clean_qf
	-$(RM) $(EXE_OBJECTS)
	-$(RM) $(DLL_OBJECTS)
	$(if $(OS:WIN=), \
		-$(RM) dpuser dpuserD \
	, \
		-$(RM) dpuser.exe dpuserD.exe dpuserCyg.exe dpuserCygD.exe \
		-$(RM) dpuser.dll dpuserD.dll dpuserCyg.dll dpuserCygD.dll\
	)

# this target is called by QFitsView 'make clean'
clean_qf: FORCE
	$(MAKE) -C parser clean  PLATFORM=$(OS)
	$(MAKE) -C dpuser2c clean PLATFORM=$(OS)
	$(MAKE) -C idl2c clean PLATFORM=$(OS)

FORCE:

################################################################################
# Updates the revision in parser/svn_revision.h
revision:
ifeq ($(OS), WIN)
	echo #include "svn_revision.h" > parser/svn_revision.cpp
	echo. >> parser/svn_revision.cpp
	echo char* GetRevString() { return "Rev. $(REV_NR)"; } >> parser/svn_revision.cpp
else
	@echo '#include "svn_revision.h"' > parser/svn_revision_new.cpp; \
	echo '' >> parser/svn_revision_new.cpp; \
	echo 'char* GetRevString() { return "Rev. $(REV_NR)"; }' >> parser/svn_revision_new.cpp; \
	cmp -s parser/svn_revision.cpp parser/svn_revision_new.cpp; \
	RETVAL=$$?; \
	if [ $$RETVAL -ne 0 ]; then \
		mv parser/svn_revision_new.cpp parser/svn_revision.cpp; \
	fi
endif
	@echo "Revision number: "$(REV_NR)


################################################################################
# Creates a distribution
ifeq ($(OS), WIN) # start WIN
dist:
	@echo "*************************************************************"

=== dpuser/idl2c/Makefile ===
# idl2c-parser/lex Makefile
################################################################################

# Macros
MV         = mv
RM         = rm -f
SED        = sed

ifeq ($(PLATFORM), WIN)
   # didn't manage to do this as onliner like in the unix-case, pipe doesn't work...
   ARCH := $(shell wmic os get osarchitecture)
   $(shell @echo $(ARCH) > _bbb.txt)
   ARCH := $(shell sed  -e "s/OSArchitecture//g" -e "s/ //g" -e "s/-bit//g" -e "s/-Bit//g" _bbb.txt)
   $(shell del _bbb.txt)

   YACC           = ..\..\bin\WIN$(ARCH)\yacc.exe
   LEX            = ..\..\bin\WIN$(ARCH)\flex.exe -i
   SED_INPLACE    = ..\..\bin\WIN$(ARCH)\sed.exe -i''
   MV             = ren
   RM             = del
  SED_STRING = $(SED_INPLACE) 's/file ? (isatty/0;\/\/file ? (isatty/g' lex.idl2c.cpp
else
   ifeq ($(shell uname -m), x86_64)
      ARCH = 64
   else
      ARCH = 32
   endif

   ifeq ($(PLATFORM), LINUX)
      YACC        = ../../bin/LINUX$(ARCH)/yacc
      LEX         = flex -l -i
      SED_INPLACE = sed -i''
   endif
   ifeq ($(PLATFORM), MACOSX)
      YACC        = yacc
      LEX         = flex -l -i
      SED_INPLACE = sed -i ''
   endif
   SED_STRING = $(SED_INPLACE) 's/extern int isatty/\/\/extern int isatty/g' lex.idl2c.cpp
endif

################################################################################
##### creates parser and lexer #####

idl2c-parser: y.idl2c.cpp lex.idl2c.cpp

y.idl2c.cpp: idl2c.y
	$(YACC) -d $<
	$(MV) y.tab.c y.idl2c.cpp

lex.idl2c.cpp: idl2c.l
	$(LEX) $<
	$(MV) lex.yy.c lex.idl2c.cpp

# all occurences of yy and YY are replaced with idl2c and IDL2C, because the lex.yy.cpp uses the same names -> error when linking
	$(SED_INPLACE) 's/yy/idl2c/g' y.idl2c.cpp lex.idl2c.cpp y.tab.h
	$(SED_INPLACE) 's/YY/IDL2C/g' y.idl2c.cpp lex.idl2c.cpp y.tab.h
# resolve the isatty problem (then-part= LINUX/MAC, else-part: WIN)
	$(SED_INPLACE) 's/extern int isatty/\/\/extern int isatty/g' lex.idl2c.cpp
	$(SED_STRING)

clean:
	$(RM) y.idl2c.cpp lex.idl2c.cpp y.tab.h y.tab.c lex.yy.c

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export QT_SELECT=qt5

%:
	dh  $@

override_dh_auto_build:
	$(MAKE) -C dpuser
	$(MAKE) -C QFitsView release_shared

override_dh_auto_test:
	cd dpuser/test && echo @testsuite.dpuser | ../dpuser | tee ../../test.log
	fgrep -q CONGRATULATIONS test.log

override_dh_installdocs:
	cd dpuser/doc && echo @makehelp.dpuser | ../../dpuser/dpuser
	cd QFitsView/doc/www && echo @makewww.dpuser | ../../../dpuser/dpuser
	test -f dpuser/doc/www/index.html
	dh_installdocs

override_dh_clean:
	$(MAKE) -C dpuser clean
	$(MAKE) -C QFitsView clean
	dh_clean

=== debian/watch ===
# format version number, currently 3; this line is compulsory!
version=3
opts=dversionmangle=s/\+dfsg//,repacksuffix=+dfsg \
 http://www.mpe.mpg.de/~ott/dpuser/dpuser.html .*dpuser.*src[_-]?(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## dpuser 3.3.1+p1+dfsg+rb2

=== QFitsView/Makefile ===
################################################################################
####       QFitsView Makefile
################################################################################
# Type one of the following lines:
#   make                    same as 'make release'
#   make release            (static, 32/64-bit autodetected)
#   make release_shared     (shared, 32/64-bit autodetected)
#   make debug              (static, 32/64-bit autodetected)
#   make debug_shared       (shared, 32/64-bit autodetected)
#   make CYGWIN=-y          WIN only, target for CYGWIN-environment
#   make clean              to clean up the project
#   make revision           creates the revision-string
#   make dist               LINUX/MACOSX only to create a distribution as
#                           tar.gz-file, calls automatically the revision-target
#                           (do a checkout to a new location before, since all
#                           .svn-folders will be deleted!)
#
#
#   make parsers PLATFORM=LINUX (or MACOSX or WIN)
#                          to create just the parsers and lexers for dpuser,
#                          dpuser2c & idl2c
#   make dpuser2c_header PLATFORM=LINUX (or MACOSX or WIN)
#                          to create just the dpuser2c.h-file
################################################################################

PARSER_DIR   = ../dpuser/parser
DPUSER2C_DIR = ../dpuser/dpuser2c
DP_PATH      = ../dpuser

ifeq ($(HOMEDRIVE), C:)
   OS     = WIN
   SED    = ../bin/WIN/sed.exe -i
   RM     = del
   RMDIR  = rmdir
else
   ifeq ($(TERM_PROGRAM), Apple_Terminal)
      OS  = MACOSX
      SED = sed -i ''
   else
      OS  = LINUX
      SED = sed -i''
   endif
   RM	  = rm -rf
endif

ifeq ($(wildcard qfitsview.mk),) 
    DO_CLEAN = NO
else 
    DO_CLEAN = YES
endif

################################################################################
##### main targets #####
all: release

all_base: revision dpuser2c_header parsers

# static binaries
release: all_base qmake-release_static qfitsview
debug:   all_base qmake-debug_static qfitsview

ifeq ($(OS), WIN)
# shared binaries for Windows
release_shared: all_base qfits-dll qmake-release_shared qfitsview
debug_shared:   all_base qfits-dll-debug qmake-debug_shared qfitsview
else
# shared binaries forLinux/MacOS 
release_shared: all_base qmake-release_shared qfitsview
debug_shared:   all_base qmake-debug_shared qfitsview
endif

################################################################################
##### sub targets #####
# updates the revision in parser/svn_revision.h
revision:
	$(MAKE) -C $(DP_PATH) revision

# creates dpuser2c.h
dpuser2c_header:
	$(MAKE) -C $(DP_PATH) dpuser2c_header

# builds parser and dpuser2c-source-files
parsers:
	$(MAKE) -C $(DP_PATH) parsers

##### create Makefiles for QFitsView #####
# release-version, shared
qmake-release_shared:
	qmake QFitsView.pro "CONFIG+=release qf_shared"

# release-version, static, without dll's
qmake-release_static:
	qmake QFitsView.pro "CONFIG+=release qf_static"

# debug-version, shared
qmake-debug_shared:
	qmake QFitsView.pro "CONFIG+=debug qf_shared"

# debug-version, static
qmake-debug_static:
	qmake QFitsView.pro "CONFIG+=debug qf_static"

# special targets for Windows, shared-version
ifeq ($(OS), WIN)
qfits-dll:
	qmake QFitsView_dll.pro "CONFIG+=release qf_shared"
	$(MAKE) $(MULTIPROZGEIL) -f QFitsView_dll.mk

qfits-dll-debug:
	qmake QFitsView_dll.pro "CONFIG+=debug qf_shared"
	$(MAKE) $(MULTIPROZGEIL) -f QFitsView_dll.mk
endif

# effectively building QFitsView
qfitsview:
	$(MAKE) $(MULTIPROZGEIL) -f qfitsview.mk

################################################################################
clean:
	$(if $(DO_CLEAN:NO=), \
		$(MAKE) $(MULTIPROZGEIL) -if qfitsview.mk clean \
	)
	$(MAKE) $(MULTIPROZGEIL) -C $(DP_PATH) clean_qf PLATFORM=$(OS)
	$(if $(OS:WIN=), \
		-$(RM) -rf QFitsView QFitsViewD qfitsview.mk qfitsview.mk.Debug qfitsview.mk.Release QFitsView.app QFitsViewD.app QFitsView.pro.user* ../include/vtk/vtkConfigure.h qfitsviewd_plugin_import.cpp qfitsview_plugin_import.cpp \
	, \
		$(RM) QFitsView_dll.mk QFitsView_dll.mk.Release QFitsView_dll.mk.Debug qfitsview.mk qfitsview.mk.Release qfitsview.mk.Debug object_script.QFitsView.Debug object_script.QFitsView.Release object_script.QFitsViewD.Debug object_script.QFitsViewD.Release /f; \
		$(RMDIR) /s /q release debug \
	)
		
#	$(if $(OS:WIN=), \
#		-$(RM) -rf QFitsView QFitsViewD qfitsview.mk qfitsview.mk.Debug qfitsview.mk.Release QFitsView.app QFitsViewD.app QFitsView.pro.user* ../include/vtk/vtkConfigure.h qfitsviewd_plugin_import.cpp \
#	, \
#		$(RM) QFitsView_dll.mk QFitsView_dll.mk.Release QFitsView_dll.mk.Debug qfitsview.mk qfitsview.mk.Release qfitsview.mk.Debug object_script.QFitsView.Debug object_script.QFitsView.Release object_script.QFitsViewD.Debug object_script.QFitsViewD.Release /f ;\
#		$(RMDIR) release debug \
#	)
	
#		$(MAKE) $(MULTIPROZGEIL) -f QFitsView_dll.mk clean; \

=== dpuser/dpuser2c/Makefile ===
################################################################################
# dpuser2c-parser/lex Makefile
################################################################################

MV         = mv
RM         = rm -f
SED        = sed

ifeq ($(PLATFORM), WIN)
   # didn't manage to do this as onliner like in the unix-case, pipe doesn't work...
   ARCH := $(shell wmic os get osarchitecture)
   $(shell @echo $(ARCH) > _bbb.txt)
   ARCH := $(shell sed  -e "s/OSArchitecture//g" -e "s/ //g" -e "s/-bit//g" -e "s/-Bit//g" _bbb.txt)
   $(shell del _bbb.txt)
   
   YACC           = ..\..\bin\WIN$(ARCH)\yacc.exe
   LEX            = ..\..\bin\WIN$(ARCH)\flex.exe
   SED_INPLACE    = ..\..\bin\WIN$(ARCH)\sed.exe -i''
   MV             = ren
   RM             = del
   SED_STRING = $(SED_INPLACE) 's/file ? (isatty/0;\/\/file ? (isatty/g' lex.dpuser2c.cpp
else
   ifeq ($(shell uname -m), x86_64)
      ARCH = 64
   else
      ARCH = 32
   endif

   ifeq ($(PLATFORM), LINUX)
      YACC        = ../../bin/LINUX$(ARCH)/yacc
      LEX         = flex -l
      SED_INPLACE = sed -i''
   endif
   ifeq ($(PLATFORM), MACOSX)
      YACC        = yacc
      LEX         = flex -l
      SED_INPLACE = sed -i ''
   endif
   SED_STRING = $(SED_INPLACE) 's/extern int isatty/\/\/extern int isatty/g' lex.dpuser2c.cpp
endif

################################################################################
##### creates parser and lexer #####
dpuser2c-parser: y.dpuser2c.cpp lex.dpuser2c.cpp

y.dpuser2c.cpp: dpuser2c.y
	$(YACC) -d $<
	$(MV) y.tab.c y.dpuser2c.cpp

lex.dpuser2c.cpp: dpuser2c.l
	$(LEX) $<
	$(MV) lex.yy.c lex.dpuser2c.cpp
# all occurences of yy and YY are replaced with dpuser2c and DPUSER2C, because the lex.yy.cpp uses the same names -> error when linking
	$(SED_INPLACE) "s/yy/dpuser2c/g" y.dpuser2c.cpp lex.dpuser2c.cpp y.tab.h
	$(SED_INPLACE) "s/YY/DPUSER2C/g" y.dpuser2c.cpp lex.dpuser2c.cpp y.tab.h
# resolve the isatty problem (then-part= LINUX/MAC, else-part: WIN)
	$(SED_INPLACE) "s/extern int isatty/\/\/extern int isatty/g" lex.dpuser2c.cpp
	$(SED_STRING)

################################################################################
# creates dpuser2c.h
#
# each sed-command works on one headerfile
# each sed-command has several sub-commands starting with -e
#    1st sub-command: strip data from beginning until 'BEGIN PARSE FOR DPUSER2C'-keysentence
#    2nd sub-command: strip data from 'END PARSE FOR DPUSER2C'-keysentence to the end
#    3rd sub-command: remove lines with comments (//)
#    4th sub-command: replace " with \" 
#    5th sub-command: insert " at the beginning of each line
#    6th sub-command: insert ", at the end of each line
header: dpuser2c.h

ifeq ($(PLATFORM), WIN)
dpuser2c.h: ../../utils/dpstring.h ../dpuser.h dpuserType.h functions.h procedures.h
	@echo char *header_str[] = { > dpuser2c.h
	$(SED) -e "1,/BEGIN PARSE FOR DPUSER2C/d" -e "/END PARSE FOR DPUSER2C/,$$d" -e "/^\/\//d" -e "s/\x22/\\\x22/g" -e "s/^/\x22 /" -e "s/$$/\x22,/" ../../utils/dpstring.h >> dpuser2c.h
	$(SED) -e "1,/BEGIN PARSE FOR DPUSER2C/d" -e "/END PARSE FOR DPUSER2C/,$$d" -e "/^\/\//d" -e "s/\x22/\\\x22/g" -e "s/^/\x22 /" -e "s/$$/\x22,/" ../dpuser.h >> dpuser2c.h
	$(SED) -e "1,/BEGIN PARSE FOR DPUSER2C/d" -e "/END PARSE FOR DPUSER2C/,$$d" -e "/^\/\//d" -e "s/\x22/\\\x22/g" -e "s/^/\x22 /" -e "s/$$/\x22,/" dpuserType.h >> dpuser2c.h
	$(SED) -e "1,/BEGIN PARSE FOR DPUSER2C/d" -e "/END PARSE FOR DPUSER2C/,$$d" -e "/^\/\//d" -e "s/\x22/\\\x22/g" -e "s/^/\x22 /" -e "s/$$/\x22,/" functions.h >> dpuser2c.h
	$(SED) -e "1,/BEGIN PARSE FOR DPUSER2C/d" -e "/END PARSE FOR DPUSER2C/,$$d" -e "/^\/\//d" -e "s/\x22/\\\x22/g" -e "s/^/\x22 /" -e "s/$$/\x22,/" procedures.h >> dpuser2c.h
	@echo "", >> dpuser2c.h
	@echo "" >> dpuser2c.h
	@echo }; >> dpuser2c.h
else
dpuser2c.h: ../../utils/dpstring.h ../dpuser.h dpuserType.h functions.h procedures.h
	@echo "char *header_str[] = {" > dpuser2c.h
	$(SED) -e '1,/BEGIN PARSE FOR DPUSER2C/d' -e '/END PARSE FOR DPUSER2C/,$$d' -e '/^\/\//d' -e 's/"/\\"/g' -e 's/^/" /' -e 's/$$/",/' ../../utils/dpstring.h >> dpuser2c.h
	$(SED) -e '1,/BEGIN PARSE FOR DPUSER2C/d' -e '/END PARSE FOR DPUSER2C/,$$d' -e '/^\/\//d' -e 's/"/\\"/g' -e 's/^/" /' -e 's/$$/",/' ../dpuser.h >> dpuser2c.h
	$(SED) -e '1,/BEGIN PARSE FOR DPUSER2C/d' -e '/END PARSE FOR DPUSER2C/,$$d' -e '/^\/\//d' -e 's/"/\\"/g' -e 's/^/" /' -e 's/$$/",/' dpuserType.h >> dpuser2c.h
	$(SED) -e '1,/BEGIN PARSE FOR DPUSER2C/d' -e '/END PARSE FOR DPUSER2C/,$$d' -e '/^\/\//d' -e 's/"/\\"/g' -e 's/^/" /' -e 's/$$/",/' functions.h >> dpuser2c.h
	$(SED) -e '1,/BEGIN PARSE FOR DPUSER2C/d' -e '/END PARSE FOR DPUSER2C/,$$d' -e '/^\/\//d' -e 's/"/\\"/g' -e 's/^/" /' -e 's/$$/",/' procedures.h >> dpuser2c.h
	@echo \"\", >> dpuser2c.h
	@echo \"\" >> dpuser2c.h
	@echo "};" >> dpuser2c.h
endif 

clean:
	$(RM) y.dpuser2c.cpp lex.dpuser2c.cpp y.tab.h y.tab.c lex.yy.c dpuser2c.h

=== dpuser/parser/Makefile ===
################################################################################
# dpuser-parser/lex Makefile
################################################################################

MV         = mv
RM         = rm -f

ifeq ($(PLATFORM), WIN)
   # didn't manage to do this as onliner like in the unix-case, pipe doesn't work...
   ARCH := $(shell wmic os get osarchitecture)
   $(shell @echo $(ARCH) > _bbb.txt)
   ARCH := $(shell sed  -e "s/OSArchitecture//g" -e "s/ //g" -e "s/-bit//g" -e "s/-Bit//g" _bbb.txt)
   $(shell del _bbb.txt)

   YACC    = ..\..\bin\WIN$(ARCH)\yacc.exe
   LEX     = ..\..\bin\WIN$(ARCH)\flex.exe
   SED     = ..\..\bin\WIN$(ARCH)\sed.exe -i''
   MV      = ren
   RM      = del
else
   ifeq ($(shell uname -m), x86_64)
      ARCH = 64
   else
      ARCH = 32
   endif

   ifeq ($(PLATFORM), LINUX)
      YACC = ../../bin/LINUX$(ARCH)/yacc
      LEX  = flex -l
      SED  = sed -i''
   endif
   ifeq ($(PLATFORM), MACOSX)
      YACC = yacc
      LEX  = flex -l
      SED  = sed -i ''
   endif
endif

dpuser-parser: y.tab.cpp lex.yy.cpp

y.tab.cpp: dpuser.y
	$(YACC) -d $<
	$(MV) y.tab.c y.tab.cpp

lex.yy.cpp: dpuser.l
	$(LEX) $<
	$(MV) lex.yy.c lex.yy.cpp
# resolve the isatty problem (only LINUX and MAC)
	$(if $(PLATFORM:WIN=), \
		$(SED) 's/extern int isatty/\/\/extern int isatty/g' lex.yy.cpp \
	)

clean:
	$(RM) y.tab.cpp lex.yy.cpp y.tab.h y.tab.c lex.yy.c svn_revision.cpp

=== utils/cmpfit/Makefile ===

OFILES  = mpfit.o
LIBFILE = libmpfit.a

all: $(LIBFILE) testmpfit

clean:
	rm -f $(OFILES) testmpfit $(LIBFILE)

mpfit.o: mpfit.c mpfit.h
	$(CC) -c -o $@ $< $(CFLAGS)

$(LIBFILE): $(OFILES)
	$(AR) r $@ $(OFILES)

testmpfit: testmpfit.c libmpfit.a
	$(CC) -o $@ $(CFLAGS) testmpfit.c -L. -lmpfit -lm

=== debian/changelog ===
dpuser (3.3.1+p1+dfsg+rb2-1+eagle) unstable; urgency=medium

  * update

 -- Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>  Wed, 27 Jan 2021 16:20:13 +0800

## dpuser 4.0%2Bdfsg

=== debian/control ===
Source: dpuser
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Ole Streicher <olebole@debian.org>
Section: science
Priority: optional
Build-Depends: bison,
               debhelper-compat (= 12),
               flex,
               giza-dev,
               libfftw3-dev,
               libgsl-dev,
               libqt5datavisualization5-dev,
               libqt5opengl5-dev,
               libqt5svg5-dev,
               libqt5x11extras5-dev,
               libreadline-dev,
               libxpa-dev,
               qtbase5-dev (>= 5.8~),
               qtchooser,
	       libz-dev
Standards-Version: 4.4.0
Vcs-Browser: https://salsa.debian.org/debian-astro-team/dpuser
Vcs-Git: https://salsa.debian.org/debian-astro-team/dpuser.git
Homepage: https://www.mpe.mpg.de/~ott/dpuser/index.html

Package: dpuser
Architecture: any
Depends: g++,
         libc6-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: dpuser-doc
Description: Interactive language for handling numbers, strings, and matrices
 DPUSER is an interactive language capable of handling numbers (both real and
 complex), strings, and matrices. Its main aim is to do astronomical image
 analysis, for which it provides a comprehensive set of functions, but it can
 also be used for many other applications.
 .
 Note that this package was compiled with the giza library instead of PGPLOT,
 since the latter is non-free software.

Package: qfitsview
Architecture: any
Depends: g++,
         libc6-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: dpuser-doc
Description: FITS file viewer based on DPUSER
 QFitsView is a FITS file viewer based on DPUSER. In addition to displaying
 two-dimensional images, it also provides means to explore three-dimensional
 data cubes. It integrates the functionality of DPUSER which can be accessed
 directly out of QFitsView.
 .
 Note that this package was compiled with the giza library instead of PGPLOT,
 since the latter is non-free software.

Package: dpuser-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Documentation for DPUSER and QFitsView
 DPUSER is an interactive language capable of handling numbers (both real and
 complex), strings, and matrices. Its main aim is to do astronomical image
 analysis, for which it provides a comprehensive set of functions, but it can
 also be used for many other applications.
 .
 This package contains the documentation for DPUSER and QFitsView.

## dpuser 4.0+dfsg

=== dpuser/Makefile ===
################################################################################
# dpuser Makefile
################################################################################
# Type one of the following lines:
#   make                    same as 'make release'
#   make release            (static, 32/64-bit autodetect)
#   make release_shared     WIN only (shared, 32/64-bit autodetect)
#   make debug              (static, 32/64-bit autodetect)
#   make debug_shared       WIN only (shared, 32/64-bit autodetect)
#   make clean              to clean up the project
#   make revision           creates the revision-string
#   make dist               LINUX/MACOSX only to create a distribution as
#                           tar.gz-file, calls automatically the revision-target
#                           (do a checkout to a new location before, since all
#                           .svn-folders will be deleted!)
#
#
#   make parsers PLATFORM=LINUX (or MACOSX or WIN)
#                          to create just the parsers and lexxers for dpuser,
#                          dpuser2c & idl2c
#   make dpuser2c_header PLATFORM=LINUX (or MACOSX or WIN)
#                          to create just the dpuser2c.h-file
#
# In dpuser a static target means that all libraries and functionality is linked
# statically into the created binary.
# A shared target means that some dpuser-functionality is moved to a dll
# (external libraries are still linked statically).
#
################################################################################
RM          = rm -f
SED         = sed
CC          = gcc
CXX         = g++
LINK        = g++
QF          =
GDL         = -DHAS_GDL
PY          = -DHAS_PYTHON

PGPLOT      = -DHAS_PGPLOT
DPPGPLOT    = -DHAS_DPPGPLOT

DEFINES     = $(PGPLOT) $(DPPGPLOT) $(GDL) $(PY) -D$(OS)
ifeq ($(QF), -qt)
   DEFINES  += -DDPQT -DNO_READLINE
endif

CFLAGS      = -pipe -O2 -D_REENTRANT -w $(DEFINES)
CXXFLAGS    = -pipe -O2 -std=c++11 -D_REENTRANT -w $(DEFINES)
INCPATH     = -I. -I../utils -I../libfits -I../include -Iparser -I.

ifeq ($(GDL), -DHAS_GDL)
   INCPATH  += -I../include/gdl
endif

OBJECTS =     dpuser_utils.o \
              dpuser.procs.o \
              helpmap.o \
              y.mpfit.o \
              mpfitAST.o \
              lex.mpfit.o \
              dpuserType.o \
              dpstring.o \
              dpstringlist.o \
              regex_sr.o \
              mpfit.o \
	            kabsch2d.o \
              3d_stuff.o \
              cube.o \
              dpheader.o \
              fits.o \
              fits_cube.o \
              fits_dpl.o \
              fits_exc.o \
              fits_file.o \
              fits_filters.o \
              fits_funcs.o \
              fits_mem.o \
              fits_ops.o \
              fits_procs.o \
              fits_range.o \
              fits_red.o \
              JulianDay.o \
              math_utils.o \
              dpComplex.o \
              fitting.o \
              voronoi.o \
              fits_logic.o \
              astrolib.o \
							arithmetics.o \
							boolean.o \
							dpuserAST.o \
              dpuser.yacchelper.o \
              functions.o \
              y.tab.o \
              dpuser.input.o \
              procedures.o \
              lex.yy.o \
              svn_revision.o \
							gdl_dpuser.o \
							python_dpuser.o

ifeq ($(PGPLOT), -DHAS_PGPLOT)
   ifeq ($(DPPGPLOT), -DHAS_DPPGPLOT)
      OBJECTS += cpg3d.o
   endif
endif

################################################################################
# Platform-specific defines

ifeq ($(HOMEDRIVE), C:)
   OS             = WIN
   RM             = del
   SED_INPLACE    = ../bin/WIN/sed.exe -i
   
   # didn't manage to do this as onliner like in the unix-case, pipe doesn't work...
   REV_NR := $(shell svnversion -c ..)
   $(shell @echo $(REV_NR) > _bbb.txt)
   REV_NR := $(shell sed -e 's/[MS]//g' -e 's/^[[:digit:]]*://' _bbb.txt)
   $(shell del _bbb.txt)

   ifndef $(ARCH)
   # didn't manage to do this as onliner like in the unix-case, pipe doesn't work...
      ARCH := $(shell wmic os get osarchitecture)
      $(shell @echo $(ARCH) > _bbb.txt)
      ARCH := $(shell sed  -e "s/OSArchitecture//g" -e "s/ //g" -e "s/-bit//g" -e "s/-Bit//g" _bbb.txt)
      $(shell del _bbb.txt)
   endif

   DEFINES  += -DHAVE_MINGW32

   LIBS =     ../lib/$(OS)$(ARCH)/libfftw3.a \
              ../lib/$(OS)$(ARCH)/libcpgplot.a \
              ../lib/$(OS)$(ARCH)/libpgplot.a \
              ../lib/$(OS)$(ARCH)/libpng.a \
              ../lib/$(OS)$(ARCH)/libxpa.a \
              ../lib/$(OS)$(ARCH)/libf2c.a \
              ../lib/$(OS)$(ARCH)/libreadline.a \
              ../lib/$(OS)$(ARCH)/libtermcap.a

   ifeq ($(GDL), -DHAS_GDL)
          LIBS  += ../lib/$(OS)$(ARCH)/libgdl.a \
                   ../lib/$(OS)$(ARCH)/libfftw3f.a \
                   ../lib/$(OS)$(ARCH)/libplplotcxx.a \
                   ../lib/$(OS)$(ARCH)/libplplot.a \
                   ../lib/$(OS)$(ARCH)/libqsastime.a \
                   ../lib/$(OS)$(ARCH)/libcsirocsa.a \
                   ../lib/$(OS)$(ARCH)/libgnurx.a \
                   ../lib/$(OS)$(ARCH)/libxdr.a \
                   -lole32 -lspoolss -lwinspool -loleaut32 -luuid
   endif
   ifeq ($(PY), -DHAS_PYTHON)
#      LIBS +=	/Programme/Python3/libs/libpython36.a
      INCPATH  += -I/Programme/Python3/include
   endif
       LIBS  += ../lib/$(OS)$(ARCH)/libgsl.a \
                ../lib/$(OS)$(ARCH)/libgslcblas.a \
								../lib/$(OS)$(ARCH)/libz.a \
                -lgdi32 -lws2_32 -lshlwapi -lcomdlg32 -lcomctl32
				 
   LDFLAG      = -static-libgcc -static-libstdc++ -Wl,--enable-runtime-pseudo-reloc
else
   REV_NR := $(shell svnversion -c .. | sed -e 's/[MS]//g' -e 's/^[[:digit:]]*://')

   ifeq ($(shell uname -m), x86_64)
      ARCH = 64
   else
      ARCH = 32
   endif

   ifeq ($(TERM_PROGRAM), Apple_Terminal)
      OS          = MACOSX
      ifeq ($(ARCH), 32)
         LDFLAG      = -arch i386
         CXXFLAGS    := -arch i386 $(CXXFLAGS)
      else
         # -arch x86_64
         LDFLAG      = 
      endif
      SED_INPLACE = sed -i ''
      LIBS        = ../lib/$(OS)$(ARCH)/libxpa.a \
                    ../lib/$(OS)$(ARCH)/libfftw3.a \
                    ../lib/$(OS)$(ARCH)/libcpgplot.a \
                    ../lib/$(OS)$(ARCH)/libpgplot.a \
                    ../lib/$(OS)$(ARCH)/libpng.a \
                    ../lib/$(OS)$(ARCH)/libgsl.a \
                    ../lib/$(OS)$(ARCH)/libgslcblas.a \
                    ../lib/$(OS)$(ARCH)/libreadline.a \
                    ../lib/$(OS)$(ARCH)/libz.a \
                    ../lib/$(OS)$(ARCH)/libncurses.a \
                    ../lib/$(OS)$(ARCH)/libf2c.a
   ifeq ($(GDL), -DHAS_GDL)
            LIBS += ../lib/$(OS)$(ARCH)/libgdl.a \
                    ../lib/$(OS)$(ARCH)/libfftw3f.a \
                    ../lib/$(OS)$(ARCH)/libplplot.a \
                    ../lib/$(OS)$(ARCH)/libplplotcxx.a \
                    ../lib/$(OS)$(ARCH)/libqsastime.a \
                    ../lib/$(OS)$(ARCH)/libcsirocsa.a
   endif
            LIBS += -L/opt/X11/lib \
                    -lX11
   ifeq ($(PY), -DHAS_PYTHON)
#            LIBS += -L/Library/Frameworks/Python.framework/Versions/3.6/lib -lpython3.6
      INCPATH  += -I/Library/Frameworks/Python.framework/Versions/3.6/include/python3.6m -I/Library/Frameworks/Python.framework/Versions/3.6/lib/python3.6/site-packages/numpy/core/include
   endif

   else
      OS          = LINUX
      LDFLAG      = -static-libstdc++ -static-libgcc
      SED_INPLACE = sed -i''
      LIBS        = -rdynamic \
                    ../lib/$(OS)$(ARCH)/libxpa.a \
                    ../lib/$(OS)$(ARCH)/libfftw3.a \
                    ../lib/$(OS)$(ARCH)/libcpgplot.a \
                    ../lib/$(OS)$(ARCH)/libpgplot.a \
                    ../lib/$(OS)$(ARCH)/libf2c.a \
                    ../lib/$(OS)$(ARCH)/libz.a \
                    ../lib/$(OS)$(ARCH)/libpng.a \
                    ../lib/$(OS)$(ARCH)/libreadline.a \
                    ../lib/$(OS)$(ARCH)/libncurses.a
   ifeq ($(GDL), -DHAS_GDL)
	LIBS +=	          ../lib/$(OS)$(ARCH)/libgdl.a \
                    ../lib/$(OS)$(ARCH)/libplplotcxx.a \
                    ../lib/$(OS)$(ARCH)/libfftw3f.a \
                    ../lib/$(OS)$(ARCH)/libplplot.a \
                    ../lib/$(OS)$(ARCH)/libqsastime.a
   endif
          LIBS +=          ../lib/$(OS)$(ARCH)/libgsl.a \
                    ../lib/$(OS)$(ARCH)/libgslcblas.a \
                    ../lib/$(OS)$(ARCH)/libz.a

   ifeq ($(PY), -DHAS_PYTHON)
#      LIBS += /usr/lib/x86_64-linux-gnu/libpython3.5m.a -lexpat -lutil
      INCPATH  += -I/usr/include/python3.5m
   endif
       LIBS +=      -lX11 -ldl -lxcb -lpthread -lXdmcp -lXau

   endif
   TARDIR     := $(shell echo $(PWD) | sed 's|/dpuser$$||g' | sed 's|\/.*\/||g')
endif

################################################################################
# main targets
all: release 

##### RELEASE TARGETS #####
ifeq ($(OS), WIN) # start WIN
release:
	$(MAKE) static "TARGET_WIN = dpuser.exe"
else # start LINUX & MACOSX
release:
	$(MAKE) static "TARGET_LINUX = dpuser"
endif # end LINUX & MACOSX

##### DEBUG TARGETS #####
ifeq ($(OS), WIN) # start WIN
debug:
	$(MAKE) static "TARGET_WIN = dpuserD.exe" "CFLAGS = $(CFLAGS) -g -DDBG" "CXXFLAGS = $(CXXFLAGS) -g -DDBG"
else # start LINUX & MACOSX
debug:
	$(MAKE) static "TARGET_LINUX = dpuserD" "CFLAGS = $(CFLAGS) -g -DDBG" "CXXFLAGS = $(CXXFLAGS) -g -DDBG"
endif # end LINUX & MACOSX

################################################################################
# sub targets

ifeq ($(OS), WIN) # start WIN
static: revision parsers
	$(MAKE) $(MULTIPROZGEIL) $(TARGET_WIN)
else # end WIN, start LINUX & MACOSX
static: doc/helpmap.cpp revision parsers
	$(MAKE) $(MULTIPROZGEIL) $(TARGET_LINUX)
endif # end LINUX & MACOSX

$(TARGET_DLL): $(DLL_OBJECTS)
	g++ -shared -o $(TARGET_DLL) $(DLL_OBJECTS) $(DLL_LIBS)

$(TARGET_WIN): $(OBJECTS)
	$(LINK) $(LDFLAG) -o $(TARGET_WIN) $(OBJECTS) $(LIBS)

$(TARGET_LINUX): $(OBJECTS)
	$(LINK) $(LDFLAG) -o $(TARGET_LINUX) $(OBJECTS) $(LIBS)

# Builds parser-, dpuser2c & idl2c-source-files
parsers: parsers_qf
	$(MAKE) -C parser PLATFORM=$(OS)

parsers_qf:
	$(MAKE) -C mpfit PLATFORM=$(OS)

clean: clean_qf
	-$(RM) $(OBJECTS)
	$(if $(OS:WIN=), \
		-$(RM) dpuser dpuserD \
	, \
		-$(RM) dpuser.exe dpuserD.exe \
	)

# this target is called by QFitsView 'make clean'
clean_qf: FORCE
	$(MAKE) -C parser clean  PLATFORM=$(OS)
	$(MAKE) -C mpfit clean PLATFORM=$(OS)

FORCE:

################################################################################
# Updates the revision in parser/svn_revision.h
revision:
ifeq ($(OS), WIN)
	echo #include "svn_revision.h" > parser/svn_revision.cpp
	echo. >> parser/svn_revision.cpp
	echo char* GetRevString() { return "Rev. $(REV_NR)"; } >> parser/svn_revision.cpp
else
	@echo '#include "svn_revision.h"' > parser/svn_revision_new.cpp; \
	echo '' >> parser/svn_revision_new.cpp; \
	echo 'char* GetRevString() { return "Rev. $(REV_NR)"; }' >> parser/svn_revision_new.cpp; \
	cmp -s parser/svn_revision.cpp parser/svn_revision_new.cpp; \
	RETVAL=$$?; \
	if [ $$RETVAL -ne 0 ]; then \
		mv parser/svn_revision_new.cpp parser/svn_revision.cpp; \
	fi
endif
	@echo "Revision number: "$(REV_NR)


################################################################################
# Creates a distribution
ifeq ($(OS), WIN) # start WIN
dist:
	@echo "*************************************************************"
	@echo "ERROR: Distribution can only be generated under LINUX or MAC!"
	@echo "*************************************************************"
else # end WIN, start LINUX & MACOSX
dist: clean
	cd ../QFitsView && make -i clean
	make revision
	find .. -type d -name ".svn" -exec rm -rf {} +
	find .. -type d -name "obsolete" -exec rm -rf {} +
	find .. -regextype posix-extended -regex '.*\.(a|lib|dll|exe)' -exec rm {} +
	rm -rf ../include/*
	rm -rf ../bin/*
	rm -rf ../external/*z

=== dpuser/mpfit/Makefile ===
# mpfit-parser/lex Makefile
################################################################################

# Macros
MV         = mv
RM         = rm -f
SED        = sed

ifeq ($(PLATFORM), WIN)
   # didn't manage to do this as onliner like in the unix-case, pipe doesn't work...
   ARCH := $(shell wmic os get osarchitecture)
   $(shell @echo $(ARCH) > _bbb.txt)
   ARCH := $(shell sed  -e "s/OSArchitecture//g" -e "s/ //g" -e "s/-bit//g" -e "s/-Bit//g" _bbb.txt)
   $(shell del _bbb.txt)

   YACC           = ..\..\bin\WIN$(ARCH)\yacc.exe
   LEX            = ..\..\bin\WIN$(ARCH)\flex.exe -i
   SED_INPLACE    = ..\..\bin\WIN$(ARCH)\sed.exe -i''
   MV             = ren
   RM             = del
  SED_STRING = $(SED_INPLACE) 's/file ? (isatty/0;\/\/file ? (isatty/g' lex.mpfit.cpp
else
   ifeq ($(shell uname -m), x86_64)
      ARCH = 64
   else
      ARCH = 32
   endif

   ifeq ($(PLATFORM), LINUX)
      YACC        = ../../bin/LINUX$(ARCH)/yacc
      LEX         = flex -l -i
      SED_INPLACE = sed -i''
   endif
   ifeq ($(PLATFORM), MACOSX)
      YACC        = yacc
      LEX         = flex -l -i
      SED_INPLACE = sed -i ''
   endif
   SED_STRING = $(SED_INPLACE) 's/extern int isatty/\/\/extern int isatty/g' lex.mpfit.cpp
endif

################################################################################
##### creates parser and lexer #####

mpfit-parser: y.mpfit.cpp lex.mpfit.cpp

y.mpfit.cpp: mpfit.y
	$(YACC) -d $<
	$(MV) y.tab.c y.mpfit.cpp

lex.mpfit.cpp: mpfit.l
	$(LEX) $<
	$(MV) lex.yy.c lex.mpfit.cpp

# all occurences of yy and YY are replaced with mpfit and MPFIT, because the lex.yy.cpp uses the same names -> error when linking
	$(SED_INPLACE) 's/yy/mpfit/g' y.mpfit.cpp lex.mpfit.cpp y.tab.h
	$(SED_INPLACE) 's/YY/MPFIT/g' y.mpfit.cpp lex.mpfit.cpp y.tab.h
# resolve the isatty problem (then-part= LINUX/MAC, else-part: WIN)
	$(SED_INPLACE) 's/extern int isatty/\/\/extern int isatty/g' lex.mpfit.cpp
	$(SED_STRING)

clean:
	$(RM) y.mpfit.cpp lex.mpfit.cpp y.tab.h y.tab.c lex.yy.c

=== dpuser/parser/Makefile ===
--- 
+++ 
@@ -25,7 +25,7 @@
    endif
 
    ifeq ($(PLATFORM), LINUX)
-      YACC = ../../bin/LINUX$(ARCH)/yacc
+      YACC = ../../bin/LINUX$(ARCH)/yacc -d
       LEX  = flex -l
       SED  = sed -i''
    endif
@@ -38,11 +38,13 @@
 
 dpuser-parser: y.tab.cpp lex.yy.cpp
 
-y.tab.cpp: dpuser.y
+#y.tab.cpp: dpuser.y
+y.tab.cpp: ast.y
 	$(YACC) -d $<
 	$(MV) y.tab.c y.tab.cpp
 
-lex.yy.cpp: dpuser.l
+#lex.yy.cpp: dpuser.l
+lex.yy.cpp: ast.l
 	$(LEX) $<
 	$(MV) lex.yy.c lex.yy.cpp
 # resolve the isatty problem (only LINUX and MAC)

=== debian/changelog ===
dpuser (4.0+dfsg-3) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Let dh_auto_configure run the right qmake (Closes: #946284)

  [ Ole Streicher ]
  * Add missing QPainterPath header (Closes: #975171)

 -- Ole Streicher <olebole@debian.org>  Thu, 19 Nov 2020 11:35:27 +0100

dpuser (4.0+dfsg-2) unstable; urgency=low

  [ Helmut Grohne ]
  * Improve cross building: Build dpuser with the right compiler.
    (Closes: #939518)

  [ Ole Streicher ]
  * Propagate CPPFLAGS for dpuser build
  * Build doc only for -all architecture
  * Wrap inclusion of .xpm files with 'extern "C"'
  * Remove VTK references in patches
  * Add icon for QFitsView
  * Make dpuser-doc Multi-Arch:foreign

 -- Ole Streicher <olebole@debian.org>  Thu, 12 Sep 2019 21:24:15 +0200

dpuser (4.0+dfsg-1) unstable; urgency=low

  * Update VCS fields to use salsa.d.o
  * Add gitlab-CI
  * Fix documentation path
  * New upstream version 4.0+dfsg
  * Rediff patches
  * Push Standards-Version to 4.4.0. Change URLs to https
  * Push compat to 12. Remove d/compat
  * Workaround gcc optimization bug
  * Use fftw3, update qt5; remove vtk build deps
  * Fix test scripts
  * Wrap override_dh_auto_test with DEB_BUILD_OPTIONS

 -- Ole Streicher <olebole@debian.org>  Wed, 04 Sep 2019 20:56:42 +0200

=== debian/rules ===
--- 
+++ 
@@ -9,14 +9,17 @@
 	dh  $@
 
 override_dh_auto_build:
-	$(MAKE) -C dpuser
-	$(MAKE) -C QFitsView release_shared
+	dh_auto_build --sourcedirectory=dpuser --no-parallel
+	dh_auto_configure --buildsystem=qmake --sourcedirectory=QFitsView -- "CONFIG+=release qf_shared"
+	dh_auto_build --buildsystem=qmake --sourcedirectory=QFitsView -- -f qfitsview.mk
 
+ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
 override_dh_auto_test:
 	cd dpuser/test && echo @testsuite.dpuser | ../dpuser | tee ../../test.log
 	fgrep -q CONGRATULATIONS test.log
+endif
 
-override_dh_installdocs:
+override_dh_installdocs-indep:
 	cd dpuser/doc && echo @makehelp.dpuser | ../../dpuser/dpuser
 	cd QFitsView/doc/www && echo @makewww.dpuser | ../../../dpuser/dpuser
 	test -f dpuser/doc/www/index.html
